> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Discover referenced resources

POST https://example.itential.io/automation-studio/discoverReferences
Content-Type: application/json

Finds all resource references from a set of specified resource identifiers.

Reference: https://docs.itential.com/itential-cloud/api-reference/automation-studio/discover-references

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `resourceIdentifiers` (list of object, optional) — Array of resource identifiers to find references for.
  - `resourceType` (string, optional) — The type of the resource.
  - `resourcePointer` (string, optional) — The pointer to the identifier value in the resource object.
  - `resourceId` (string, optional) — The value of the identifier in the resource object.
  - `recursionDepth` (integer, optional) — Specifies the number of hierarchical levels to traverse when discovering references for this component. If omitted, the search on this component will be fully recursive.
- `recursive` (boolean, optional, default: false) — If true, recursively looks up resources on all referenced resources.
- `includeResources` (boolean, optional, default: false) — If true, include the full resource document in each resource reference object.
- `ignore` (map from string to enum, optional) — An object of resource types to directions that will not be included in discovery. Cannot be used with include.
  - Allowed values: `up`, `down`, `all`
- `include` (map from string to enum, optional) — An object of resource types and directions to be included in discovery. Cannot be used with ignore.
  - Allowed values: `up`, `down`, `all`
- `removeCycles` (boolean, optional, default: false) — If true, removes all cyclic relationships from the list of resource references.

## Response

### 200

References

- `message` (string, optional)
- `data` (map from string to list of object, optional, nullable)
  - `resourceType` (string, required)
  - `resourcePointer` (string, required)
  - `resourceId` (string, required)
  - `parents` (list of object, required)
    - `resourceType` (string, required)
    - `resourcePointer` (string, required)
    - `resourceId` (string, required)
    - `parentPointer` (string, required)
    - `root` (boolean, optional)
  - `root` (boolean, optional)
  - `resource` (object, optional) — When using 'includeResources', this property will contain the full resource object
- `metadata` (object, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "message": "string",
  "data": {},
  "metadata": {}
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/automation-studio/discoverReferences"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/automation-studio/discoverReferences';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/automation-studio/discoverReferences"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/automation-studio/discoverReferences")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/automation-studio/discoverReferences")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/automation-studio/discoverReferences', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/automation-studio/discoverReferences");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/automation-studio/discoverReferences")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```